Index: trunk/LMDZ.COMMON/libf/evolution/pem.F90
===================================================================
--- trunk/LMDZ.COMMON/libf/evolution/pem.F90	(revision 3145)
+++ trunk/LMDZ.COMMON/libf/evolution/pem.F90	(revision 3149)
@@ -13,6 +13,6 @@
 ! II  Run
 !    II_a Update pressure, ice and tracers
-!    II_b Evolution of the ice
-!    II_c CO2 & H2O glaciers flows
+!    II_b Evolution of ice
+!    II_c Flow of glaciers
 !    II_d Update surface and soil temperatures
 !    II_e Outputs
@@ -28,47 +28,45 @@
 PROGRAM pem
 
-use phyetat0_mod,                 only: phyetat0
-use phyredem,                     only: physdem0, physdem1
-use netcdf,                       only: nf90_open, NF90_NOWRITE, nf90_get_var, nf90_inq_varid, nf90_close
-use turb_mod,                     only: q2, wstar
-use comslope_mod,                 only: nslope, def_slope, def_slope_mean, subslope_dist, iflat, major_slope, ini_comslope_h
-use logic_mod,                    only: iflag_phys
-use mod_const_mpi,                only: COMM_LMDZ
+use phyetat0_mod,                only: phyetat0
+use phyredem,                    only: physdem0, physdem1
+use netcdf,                      only: nf90_open, NF90_NOWRITE, nf90_get_var, nf90_inq_varid, nf90_close
+use turb_mod,                    only: q2, wstar
+use comslope_mod,                only: nslope, def_slope, def_slope_mean, subslope_dist, iflat, major_slope, ini_comslope_h
+use logic_mod,                   only: iflag_phys
+use mod_const_mpi,               only: COMM_LMDZ
 use infotrac
-use geometry_mod,                 only: latitude_deg
-use conf_pem_mod,                 only: conf_pem
-use pemredem,                     only: pemdem0, pemdem1
-use glaciers_mod,                 only: co2glaciers_evol, h2oglaciers_evol, co2glaciersflow, h2oglaciersflow
-use criterion_pem_stop_mod,       only: criterion_waterice_stop, criterion_co2_stop
-use constants_marspem_mod,        only: alpha_clap_co2, beta_clap_co2, alpha_clap_h2o, beta_clap_h2o, m_co2, &
-                                        m_noco2, threshold_h2o_frost2perennial, threshold_co2_frost2perennial
-use evol_co2_ice_s_mod,           only: evol_co2_ice_s
-use evol_h2o_ice_s_mod,           only: evol_h2o_ice_s
-use comsoil_h_PEM,                only: soil_pem, ini_comsoil_h_PEM, end_comsoil_h_PEM, nsoilmx_PEM, &
-                                        TI_PEM, inertiedat_PEM,           & ! soil thermal inertia
-                                        tsoil_PEM, mlayer_PEM, layer_PEM, & ! Soil temp, number of subsurface layers, soil mid layer depths
-                                        fluxgeo,                          & ! Geothermal flux for the PEM and PCM
-                                        water_reservoir                     ! Water ressources
-use adsorption_mod,               only: regolith_adsorption, adsorption_pem,        & ! Bool to check if adsorption, main subroutine
-                                        ini_adsorption_h_PEM, end_adsorption_h_PEM, & ! Allocate arrays
-                                        co2_adsorbded_phys, h2o_adsorbded_phys        ! Mass of co2 and h2O adsorbded
-use time_evol_mod,                only: dt_pem, evol_orbit_pem, Max_iter_pem, convert_years, year_bp_ini
-use orbit_param_criterion_mod,    only: orbit_param_criterion
-use recomp_orb_param_mod,         only: recomp_orb_param
-use ice_table_mod,                only: porefillingice_depth, porefillingice_thickness, end_ice_table_porefilling, &
-                                        ini_ice_table_porefilling, computeice_table_equilibrium,compute_massh2o_exchange_ssi
-use soil_thermalproperties_mod,   only: update_soil_thermalproperties
-use time_phylmdz_mod,             only: daysec, dtphys, day_end
-use abort_pem_mod,                only: abort_pem
-use soil_settings_PEM_mod,        only: soil_settings_PEM
-use compute_tendencies_slope_mod, only: compute_tendencies_slope
-use info_PEM_mod,                 only: info_PEM
-use interpolate_TIPEM_TIGCM_mod,  only: interpolate_TIPEM_TIGCM
-use nb_time_step_PCM_mod,         only: nb_time_step_PCM
-use pemetat0_mod,                 only: pemetat0
-use read_data_PCM_mod,            only: read_data_PCM
-use recomp_tend_co2_slope_mod,    only: recomp_tend_co2_slope
-use soil_pem_compute_mod,         only: soil_pem_compute
-use writediagpem_mod,             only: writediagpem
+use geometry_mod,                only: latitude_deg
+use conf_pem_mod,                only: conf_pem
+use pemredem,                    only: pemdem0, pemdem1
+use glaciers_mod,                only: flow_co2glaciers, flow_h2oglaciers, co2_ice_flow, h2o_ice_flow
+use stopping_crit_mod,           only: stopping_crit_h2o_ice, stopping_crit_co2
+use constants_marspem_mod,       only: alpha_clap_co2, beta_clap_co2, alpha_clap_h2o, beta_clap_h2o, m_co2, &
+                                       m_noco2, inf_h2oice_threshold
+use evol_ice_mod,                only: evol_co2_ice, evol_h2o_ice
+use comsoil_h_PEM,               only: soil_pem, ini_comsoil_h_PEM, end_comsoil_h_PEM, nsoilmx_PEM, &
+                                       TI_PEM, inertiedat_PEM,           & ! soil thermal inertia
+                                       tsoil_PEM, mlayer_PEM, layer_PEM, & ! Soil temp, number of subsurface layers, soil mid layer depths
+                                       fluxgeo                             ! Geothermal flux for the PEM and PCM
+use adsorption_mod,              only: regolith_adsorption, adsorption_pem,        & ! Bool to check if adsorption, main subroutine
+                                       ini_adsorption_h_PEM, end_adsorption_h_PEM, & ! Allocate arrays
+                                       co2_adsorbded_phys, h2o_adsorbded_phys        ! Mass of co2 and h2O adsorbded
+use time_evol_mod,               only: dt_pem, evol_orbit_pem, Max_iter_pem, convert_years, year_bp_ini
+use orbit_param_criterion_mod,   only: orbit_param_criterion
+use recomp_orb_param_mod,        only: recomp_orb_param
+use ice_table_mod,               only: porefillingice_depth, porefillingice_thickness, end_ice_table_porefilling, &
+                                       ini_ice_table_porefilling, computeice_table_equilibrium,compute_massh2o_exchange_ssi
+use soil_thermalproperties_mod,  only: update_soil_thermalproperties
+use time_phylmdz_mod,            only: daysec, dtphys, day_end
+use abort_pem_mod,               only: abort_pem
+use soil_settings_PEM_mod,       only: soil_settings_PEM
+use compute_tend_mod,            only: compute_tend
+use info_PEM_mod,                only: info_PEM
+use interpol_TI_PEM2PCM_mod, only: interpol_TI_PEM2PCM
+use nb_time_step_PCM_mod,        only: nb_time_step_PCM
+use pemetat0_mod,                only: pemetat0
+use read_data_PCM_mod,           only: read_data_PCM
+use recomp_tend_co2_slope_mod,   only: recomp_tend_co2_slope
+use soil_pem_compute_mod,        only: soil_pem_compute
+use writediagpem_mod,            only: writediagpem
 
 #ifndef CPP_STD
@@ -77,12 +75,11 @@
                                   albedodat, zmea, zstd, zsig, zgam, zthe,     &
                                   hmons, summit, base,albedo_h2o_frost,        &
-                                  frost_albedo_threshold, emissiv, watercaptag, perennial_co2ice, &
-                                  emisice, albedice
+                                  frost_albedo_threshold, emissiv, watercaptag, perennial_co2ice, emisice, albedice
     use dimradmars_mod,     only: totcloudfrac, albedo
     use dust_param_mod,     only: tauscaling
-    use tracer_mod,         only: noms,igcm_h2o_ice, igcm_co2, mmol, igcm_h2o_vap ! Tracer names and molar masses
+    use tracer_mod,         only: noms, igcm_h2o_ice, igcm_co2, mmol, igcm_h2o_vap ! Tracer names and molar masses
     use mod_phys_lmdz_para, only: is_parallel, is_sequential, is_mpi_root, is_omp_root, is_master
     use planete_h,          only: aphelie, periheli, year_day, peri_day, obliquit, iniorbit
-    use paleoclimate_mod,   only: albedo_perennialco2
+    use paleoclimate_mod,   only: albedo_perennialco2, paleoclimate
     use comcstfi_h,         only: pi, rad, g, cpp, mugaz, r
     use surfini_mod,        only: surfini
@@ -127,7 +124,7 @@
 integer            :: day_ini      ! First day of the simulation
 real               :: pday         ! Physical day
-real               :: time_phys    ! Same as PCM
-real               :: ptimestep    ! Same as PCM
-real               :: ztime_fin    ! Same as PCM
+real               :: time_phys    ! Same as in PCM
+real               :: ptimestep    ! Same as in PCM
+real               :: ztime_fin    ! Same as in PCM
 
 ! Variables to read start.nc
@@ -140,6 +137,6 @@
 real, dimension(:,:,:), allocatable :: q             ! champs advectes
 real, dimension(ip1jmp1)            :: ps            ! pression au sol
-real, dimension(:),     allocatable :: ps_start_GCM  ! (ngrid) pression  au sol
-real, dimension(:,:),   allocatable :: ps_timeseries ! (ngrid x timelen) ! pression au sol instantannées
+real, dimension(:),     allocatable :: ps_start_PCM  ! (ngrid) surface pressure
+real, dimension(:,:),   allocatable :: ps_timeseries ! (ngrid x timelen) instantaneous surface pressure
 real, dimension(ip1jmp1,llm)        :: masse         ! masse d'air
 real, dimension(ip1jmp1)            :: phis          ! geopotentiel au sol
@@ -161,16 +158,16 @@
 
 ! Variables for h2o_ice evolution
-real                                :: ini_surf_h2o         ! Initial surface of sublimating h2o ice
-real                                :: global_ave_press_GCM ! constant: global average pressure retrieved in the GCM [Pa]
-real                                :: global_ave_press_old ! constant: Global average pressure of initial/previous time step
-real                                :: global_ave_press_new ! constant: Global average pressure of current time step
-real, dimension(:,:),   allocatable :: zplev_new            ! Physical x Atmospheric field : mass of the atmospheric  layers in the pem at current time step [kg/m^2]
-real, dimension(:,:),   allocatable :: zplev_gcm            ! same but retrieved from the PCM [kg/m^2]
+real, dimension(:,:),   allocatable :: h2o_ice              ! h2o ice in the PEM
+real, dimension(:,:),   allocatable :: h2o_ice_ini          ! Initial amount of h2o ice in the PEM
+real, dimension(:,:,:), allocatable :: min_h2o_ice          ! Minima of h2o ice at each point for the PCM years [kg/m^2]
+real                                :: h2o_surf_ini         ! Initial surface of sublimating h2o ice
+real                                :: global_avg_press_PCM ! constant: global average pressure retrieved in the PCM [Pa]
+real                                :: global_avg_press_old ! constant: Global average pressure of initial/previous time step
+real                                :: global_avg_press_new ! constant: Global average pressure of current time step
+real, dimension(:,:),   allocatable :: zplev_new            ! Physical x Atmospheric field: mass of the atmospheric  layers in the pem at current time step [kg/m^2]
+real, dimension(:,:),   allocatable :: zplev_PCM            ! same but retrieved from the PCM [kg/m^2]
 real, dimension(:,:,:), allocatable :: zplev_new_timeseries ! Physical x Atmospheric x Time: same as zplev_new, but in times series [kg/m ^2]
 real, dimension(:,:,:), allocatable :: zplev_old_timeseries ! same but with the time series, for oldest time step
-logical                             :: STOPPING_water       ! Logical: is the criterion (% of change in the surface of sublimating water ice) reached?
-logical                             :: STOPPING_1_water     ! Logical: is there still water ice to sublimate?
-logical                             :: STOPPING_pressure    ! Logical: is the criterion (% of change in the surface pressure) reached?
-integer                             :: criterion_stop       ! which criterion is reached ? 1= h2o ice surf, 2 = co2 ice surf, 3 = ps, 4 = orb param
+integer                             :: stopPEM              ! which criterion is reached? 0 = no stopping; 1 = h2o ice surf; 2 = no h2o ice; 3 = co2 ice surf; 4 = ps; 5 = orb param; 6 = end of simu
 real, save                          :: A, B, mmean          ! Molar mass: intermediate A, B for computations of the  mean molar mass of the layer [mol/kg]
 real, dimension(:,:),   allocatable :: q_h2o_PEM_phys       ! Physics x Times: h2o mass mixing ratio computed in the PEM, first value comes from PCM [kg/kg]
@@ -181,44 +178,39 @@
 
 ! Variables for co2_ice evolution
-real                              :: ini_surf_co2         ! Initial surface of sublimating co2 ice
-logical                           :: STOPPING_co2         ! Logical: is the criterion (% of change in the surface of sublimating co2 ice) reached?
-real, dimension(:,:), allocatable :: vmr_co2_gcm          ! Physics x Times  co2 volume mixing ratio retrieve from the PCM [m^3/m^3]
-real, dimension(:,:), allocatable :: vmr_co2_pem_phys     ! Physics x Times  co2 volume mixing ratio used in the PEM
-real, dimension(:,:), allocatable :: q_co2_PEM_phys       ! Physics x Times co2 mass mixing ratio in the first layer computed in the PEM, first value comes from PCM [kg/kg]
-real, dimension(:,:), allocatable :: co2frost_ini         ! Initial amount of co2 frost (at the start of the PEM run)
-real, dimension(:,:), allocatable :: perennial_co2ice_ini ! Initial amoun of perennial co2 ice (at the start of the PEM run)
+real, dimension(:,:),   allocatable :: co2_ice          ! co2 ice in the PEM
+real, dimension(:,:),   allocatable :: co2_ice_ini      ! Initial amount of co2 ice in the PEM
+real, dimension(:,:,:), allocatable :: min_co2_ice      ! Minimum of co2 ice at each point for the first year [kg/m^2]
+real                                :: co2_surf_ini     ! Initial surface of sublimating co2 ice
+real, dimension(:,:),   allocatable :: vmr_co2_PCM      ! Physics x Times co2 volume mixing ratio retrieve from the PCM [m^3/m^3]
+real, dimension(:,:),   allocatable :: vmr_co2_PEM_phys ! Physics x Times co2 volume mixing ratio used in the PEM
+real, dimension(:,:),   allocatable :: q_co2_PEM_phys   ! Physics x Times co2 mass mixing ratio in the first layer computed in the PEM, first value comes from PCM [kg/kg]
 
 ! Variables for slopes
-real, dimension(:,:),   allocatable :: min_co2_ice_1          ! ngrid field: minimum of co2 ice at each point for the first year [kg/m^2]
-real, dimension(:,:),   allocatable :: min_co2_ice_2          ! ngrid field: minimum of co2 ice at each point for the second year [kg/m^2]
-real, dimension(:,:),   allocatable :: min_h2o_ice_1          ! ngrid field: minimum of water ice at each point for the first year [kg/m^2]
-real, dimension(:,:),   allocatable :: min_h2o_ice_2          ! ngrid field: minimum of water ice at each point for the second year [kg/m^2]
-real, dimension(:,:,:), allocatable :: co2_ice_GCM            ! Physics x NSLOPE x Times field: co2 ice given by the PCM  [kg/m^2]
-real, dimension(:,:),   allocatable :: initial_co2_ice_sublim ! physical point field: Logical array indicating sublimating point of co2 ice
-real, dimension(:,:),   allocatable :: initial_h2o_ice        ! physical point field: Logical array indicating if there is water ice at initial state
-real, dimension(:,:),   allocatable :: initial_co2_ice        ! physical point field: Logical array indicating if there is co2 ice at initial state
-real, dimension(:,:),   allocatable :: tendencies_co2_ice     ! physical point x slope field: Tendency of evolution of perennial co2 ice over a year
-real, dimension(:,:),   allocatable :: tendencies_co2_ice_ini ! physical point x slope field x nslope: Tendency of evolution of perennial co2 ice over a year in the PCM
-real, dimension(:,:),   allocatable :: tendencies_h2o_ice     ! physical point x slope  field: Tendency of evolution of perennial h2o ice
-real, dimension(:,:),   allocatable :: flag_co2flow           ! (ngrid,nslope): Flag where there is a CO2 glacier flow
-real, dimension(:),     allocatable :: flag_co2flow_mesh      ! (ngrid)       : Flag where there is a CO2 glacier flow
-real, dimension(:,:),   allocatable :: flag_h2oflow           ! (ngrid,nslope): Flag where there is a H2O glacier flow
-real, dimension(:),     allocatable :: flag_h2oflow_mesh      ! (ngrid)       : Flag where there is a H2O glacier flow
+real, dimension(:,:,:), allocatable :: co2_ice_PCM        ! Physics x NSLOPE x Times field: co2 ice given by the PCM [kg/m^2]
+real, dimension(:,:),   allocatable :: co2_ice_ini_sublim ! physical point field: Logical array indicating sublimating point of co2 ice
+real, dimension(:,:),   allocatable :: initial_h2o_ice    ! physical point field: Logical array indicating if there is water ice at initial state
+real, dimension(:,:),   allocatable :: tend_co2_ice       ! physical point x slope field: Tendency of evolution of perennial co2 ice over a year
+real, dimension(:,:),   allocatable :: tend_co2_ice_ini   ! physical point x slope field x nslope: Tendency of evolution of perennial co2 ice over a year in the PCM
+real, dimension(:,:),   allocatable :: tend_h2o_ice       ! physical point x slope  field: Tendency of evolution of perennial h2o ice
+real, dimension(:,:),   allocatable :: flag_co2flow       ! (ngrid,nslope): Flag where there is a CO2 glacier flow
+real, dimension(:),     allocatable :: flag_co2flow_mesh  ! (ngrid)       : Flag where there is a CO2 glacier flow
+real, dimension(:,:),   allocatable :: flag_h2oflow       ! (ngrid,nslope): Flag where there is a H2O glacier flow
+real, dimension(:),     allocatable :: flag_h2oflow_mesh  ! (ngrid)       : Flag where there is a H2O glacier flow
 
 ! Variables for surface and soil
-real, dimension(:,:),     allocatable :: tsurf_ave                          ! Physic x SLOPE field : Averaged Surface Temperature [K]
-real, dimension(:,:,:),   allocatable :: tsoil_ave                          ! Physic x SOIL x SLOPE field : Averaged Soil Temperature [K]
-real, dimension(:,:,:),   allocatable :: tsurf_GCM_timeseries               ! ngrid x SLOPE XTULES field : Surface Temperature in timeseries [K]
-real, dimension(:,:,:,:), allocatable :: tsoil_phys_PEM_timeseries          ! IG x SLOPE XTULES field : NOn averaged Soil Temperature [K]
-real, dimension(:,:,:,:), allocatable :: tsoil_GCM_timeseries               ! IG x SLOPE XTULES field : NOn averaged Soil Temperature [K]
-real, dimension(:,:),     allocatable :: tsurf_ave_yr1                      ! Physic x SLOPE field : Averaged Surface Temperature of first call of the PCM [K]
+real, dimension(:,:),     allocatable :: tsurf_ave                          ! Physic x SLOPE field: Averaged Surface Temperature [K]
+real, dimension(:,:,:),   allocatable :: tsoil_ave                          ! Physic x SOIL x SLOPE field: Averaged Soil Temperature [K]
+real, dimension(:,:,:),   allocatable :: tsurf_PCM_timeseries               ! ngrid x SLOPE XTULES field: Surface Temperature in timeseries [K]
+real, dimension(:,:,:,:), allocatable :: tsoil_phys_PEM_timeseries          ! IG x SLOPE XTULES field: Non averaged Soil Temperature [K]
+real, dimension(:,:,:,:), allocatable :: tsoil_PCM_timeseries               ! IG x SLOPE XTULES field: Non averaged Soil Temperature [K]
+real, dimension(:,:),     allocatable :: tsurf_avg_yr1                      ! Physic x SLOPE field: Averaged Surface Temperature of first call of the PCM [K]
 real, dimension(:,:),     allocatable :: TI_locslope                        ! Physic x Soil: Intermediate thermal inertia  to compute Tsoil [SI]
 real, dimension(:,:),     allocatable :: Tsoil_locslope                     ! Physic x Soil: intermediate when computing Tsoil [K]
-real, dimension(:),       allocatable :: Tsurf_locslope                     ! Physic x Soil: Intermediate surface temperature  to compute Tsoil [K]
+real, dimension(:),       allocatable :: Tsurf_locslope                     ! Physic x Soil: Intermediate surface temperature to compute Tsoil [K]
 real, dimension(:,:,:,:), allocatable :: watersoil_density_timeseries       ! Physic x Soil x Slope x Times water soil density, time series [kg /m^3]
 real, dimension(:,:),     allocatable :: watersurf_density_ave              ! Physic x Slope, water surface density, yearly averaged [kg/m^3]
 real, dimension(:,:,:,:), allocatable :: watersoil_density_PEM_timeseries   ! Physic x Soil x Slope x Times, water soil density, time series [kg/m^3]
 real, dimension(:,:,:),   allocatable :: watersoil_density_PEM_ave          ! Physic x Soil x SLopes, water soil density, yearly averaged [kg/m^3]
-real, dimension(:,:),     allocatable :: Tsurfave_before_saved              ! Surface temperature saved from previous time step [K]
+real, dimension(:,:),     allocatable :: Tsurfavg_before_saved              ! Surface temperature saved from previous time step [K]
 real, dimension(:),       allocatable :: delta_co2_adsorbded                ! Physics: quantity of CO2 that is exchanged because of adsorption / desorption [kg/m^2]
 real, dimension(:),       allocatable :: delta_h2o_adsorbded                ! Physics: quantity of H2O that is exchanged because of adsorption / desorption [kg/m^2]
@@ -236,6 +228,4 @@
 integer         :: n_myear       ! Maximum number of Martian years of the chained simulations
 real            :: timestep      ! timestep [s]
-real            :: watercap_sum  ! total mass of water cap [kg/m^2]
-real            :: water_sum     ! total mass of water in the mesh [kg/m^2]
 
 #ifdef CPP_STD
@@ -341,9 +331,9 @@
 !------------------------
 ! I_b.1 Read start_evol.nc
-allocate(ps_start_GCM(ngrid))
+allocate(ps_start_PCM(ngrid))
 #ifndef CPP_1D
     call dynetat0(start_name,vcov,ucov,teta,q,masse,ps,phis,time_0)
 
-    call gr_dyn_fi(1,iip1,jjp1,ngridmx,ps,ps_start_GCM)
+    call gr_dyn_fi(1,iip1,jjp1,ngridmx,ps,ps_start_PCM)
 
     call iniconst !new
@@ -359,8 +349,7 @@
     status = nf90_close(ncid)
 
-    call iniphysiq(iim,jjm,llm,(jjm-1)*iim+2,comm_lmdz,daysec,day_ini,dtphys/nsplit_phys, &
-                   rlatu,rlatv,rlonu,rlonv,aire,cu,cv,rad,g,r,cpp,iflag_phys)
+    call iniphysiq(iim,jjm,llm,(jjm-1)*iim+2,comm_lmdz,daysec,day_ini,dtphys/nsplit_phys,rlatu,rlatv,rlonu,rlonv,aire,cu,cv,rad,g,r,cpp,iflag_phys)
 #else
-    ps_start_GCM(1) = ps(1)
+    ps_start_PCM(1) = ps(1)
 #endif
 
@@ -387,5 +376,5 @@
 #ifndef CPP_STD
     call phyetat0(startfi_name,0,0,nsoilmx,ngrid,nlayer,nq,nqsoil,day_ini,time_phys,tsurf, &
-                  tsoil,albedo,emis,q2,qsurf,qsoil,tauscaling,totcloudfrac,wstar,       &
+                  tsoil,albedo,emis,q2,qsurf,qsoil,tauscaling,totcloudfrac,wstar,          &
                   watercap,perennial_co2ice,def_slope,def_slope_mean,subslope_dist)
 
@@ -414,6 +403,6 @@
     allocate(inertiesoil(ngrid,nsoilmx,1))
     call phyetat0(.true.,ngrid,nlayer,startfi_name,0,0,nsoilmx,nq,nqsoil,day_ini,time_phys, &
-                  tsurf_read_generic,tsoil_read_generic,emis_read_generic,q2,            &
-                  qsurf_read_generic,qsoil_read_generic,cloudfrac,totcloudfrac,hice,     &
+                  tsurf_read_generic,tsoil_read_generic,emis_read_generic,q2,               &
+                  qsurf_read_generic,qsoil_read_generic,cloudfrac,totcloudfrac,hice,        &
                   rnat,pctsrf_sic,tslab,tsea_ice,sea_ice)
     call surfini(ngrid,nq,qsurf_read_generic,albedo_read_generic,albedo_bareground,albedo_snow_SPECTV,albedo_co2_ice_SPECTV)
@@ -422,13 +411,13 @@
     call ini_comslope_h(ngrid,1)
 
-    qsurf(:,:,1) = qsurf_read_generic(:,:)
-    tsurf(:,1) = tsurf_read_generic(:)
-    tsoil(:,:,1) = tsoil_read_generic(:,:)
-    emis(:,1) = emis_read_generic(:)
+    qsurf(:,:,1) = qsurf_read_generic
+    tsurf(:,1) = tsurf_read_generic
+    tsoil(:,:,1) = tsoil_read_generic
+    emis(:,1) = emis_read_generic
     watercap(:,1) = 0.
     watercaptag(:) = .false.
     albedo(:,1,1) = albedo_read_generic(:,1)
     albedo(:,2,1) = albedo_read_generic(:,2)
-    inertiesoil(:,:,1) = inertiedat(:,:)
+    inertiesoil(:,:,1) = inertiedat
 
     if (nslope == 1) then
@@ -440,5 +429,5 @@
 
     ! Remove unphysical values of surface tracer
-    qsurf(:,:,1) = qsurf_read_generic(:,:)
+    qsurf(:,:,1) = qsurf_read_generic
     where (qsurf < 0.) qsurf = 0.
 #endif
@@ -472,8 +461,8 @@
 allocate(flag_h2oflow_mesh(ngrid))
 
-flag_co2flow(:,:) = 0
-flag_co2flow_mesh(:) = 0
-flag_h2oflow(:,:) = 0
-flag_h2oflow_mesh(:) = 0
+flag_co2flow = 0
+flag_co2flow_mesh = 0
+flag_h2oflow = 0
+flag_h2oflow_mesh = 0
 
 !------------------------
@@ -486,20 +475,18 @@
 allocate(tsoil_ave(ngrid,nsoilmx,nslope))
 allocate(watersoil_density_PEM_ave(ngrid,nsoilmx_PEM,nslope))
-allocate(vmr_co2_gcm(ngrid,timelen))
+allocate(vmr_co2_PCM(ngrid,timelen))
 allocate(ps_timeseries(ngrid,timelen))
-allocate(min_co2_ice_1(ngrid,nslope))
-allocate(min_h2o_ice_1(ngrid,nslope))
-allocate(min_co2_ice_2(ngrid,nslope))
-allocate(min_h2o_ice_2(ngrid,nslope))
-allocate(tsurf_ave_yr1(ngrid,nslope))
+allocate(min_co2_ice(ngrid,nslope,2))
+allocate(min_h2o_ice(ngrid,nslope,2))
+allocate(tsurf_avg_yr1(ngrid,nslope))
 allocate(tsurf_ave(ngrid,nslope))
-allocate(tsurf_GCM_timeseries(ngrid,nslope,timelen))
-allocate(tsoil_GCM_timeseries(ngrid,nsoilmx,nslope,timelen))
+allocate(tsurf_PCM_timeseries(ngrid,nslope,timelen))
+allocate(tsoil_PCM_timeseries(ngrid,nsoilmx,nslope,timelen))
 allocate(q_co2_PEM_phys(ngrid,timelen))
 allocate(q_h2o_PEM_phys(ngrid,timelen))
-allocate(co2_ice_GCM(ngrid,nslope,timelen))
+allocate(co2_ice_PCM(ngrid,nslope,timelen))
 allocate(watersurf_density_ave(ngrid,nslope))
 allocate(watersoil_density_timeseries(ngrid,nsoilmx,nslope,timelen))
-allocate(Tsurfave_before_saved(ngrid,nslope))
+allocate(Tsurfavg_before_saved(ngrid,nslope))
 allocate(tsoil_phys_PEM_timeseries(ngrid,nsoilmx_PEM,nslope,timelen))
 allocate(watersoil_density_PEM_timeseries(ngrid,nsoilmx_PEM,nslope,timelen))
@@ -508,17 +495,17 @@
 allocate(delta_h2o_icetablesublim(ngrid))
 allocate(delta_h2o_adsorbded(ngrid))
-allocate(vmr_co2_pem_phys(ngrid,timelen))
+allocate(vmr_co2_PEM_phys(ngrid,timelen))
 
 write(*,*) "Downloading data Y1..."
-call read_data_PCM("data_PCM_Y1.nc",timelen, iim,jjm_value,ngrid,nslope,vmr_co2_gcm,ps_timeseries,min_co2_ice_1,min_h2o_ice_1, &
-                   tsurf_ave_yr1,tsoil_ave, tsurf_GCM_timeseries,tsoil_GCM_timeseries,q_co2_PEM_phys,q_h2o_PEM_phys,           &
-                   co2_ice_GCM,watersurf_density_ave,watersoil_density_timeseries)
+call read_data_PCM("data_PCM_Y1.nc",timelen, iim,jjm_value,ngrid,nslope,vmr_co2_PCM,ps_timeseries,min_co2_ice(:,:,1),min_h2o_ice(:,:,1), &
+                   tsurf_avg_yr1,tsoil_ave,tsurf_PCM_timeseries,tsoil_PCM_timeseries,q_co2_PEM_phys,q_h2o_PEM_phys,                      &
+                   co2_ice_PCM,watersurf_density_ave,watersoil_density_timeseries)
 write(*,*) "Downloading data Y1 done"
 
 ! Then we read the evolution of water and co2 ice (and the mass mixing ratio) over the second year of the PCM run, saving only the minimum value
 write(*,*) "Downloading data Y2"
-call read_data_PCM("data_PCM_Y2.nc",timelen,iim,jjm_value,ngrid,nslope,vmr_co2_gcm,ps_timeseries,min_co2_ice_2,min_h2o_ice_2, &
-                   tsurf_ave,tsoil_ave, tsurf_GCM_timeseries,tsoil_GCM_timeseries,q_co2_PEM_phys,q_h2o_PEM_phys,              &
-                   co2_ice_GCM,watersurf_density_ave,watersoil_density_timeseries)
+call read_data_PCM("data_PCM_Y2.nc",timelen,iim,jjm_value,ngrid,nslope,vmr_co2_PCM,ps_timeseries,min_co2_ice(:,:,2),min_h2o_ice(:,:,2), &
+                   tsurf_ave,tsoil_ave,tsurf_PCM_timeseries,tsoil_PCM_timeseries,q_co2_PEM_phys,q_h2o_PEM_phys,                         &
+                   co2_ice_PCM,watersurf_density_ave,watersoil_density_timeseries)
 write(*,*) "Downloading data Y2 done"
 
@@ -536,16 +523,14 @@
 if (soil_pem) then
     call soil_settings_PEM(ngrid,nslope,nsoilmx_PEM,nsoilmx,inertiesoil,TI_PEM)
-    do l = 1,nsoilmx
-        tsoil_PEM(:,l,:) = tsoil_ave(:,l,:)
-        tsoil_phys_PEM_timeseries(:,l,:,:) = tsoil_GCM_timeseries(:,l,:,:)
-        watersoil_density_PEM_timeseries(:,l,:,:) = watersoil_density_timeseries(:,l,:,:)
-    enddo
+    tsoil_PEM(:,1:nsoilmx,:) = tsoil_ave
+    tsoil_phys_PEM_timeseries(:,1:nsoilmx,:,:) = tsoil_PCM_timeseries
+    watersoil_density_PEM_timeseries(:,1:nsoilmx,:,:) = watersoil_density_timeseries
     do l = nsoilmx + 1,nsoilmx_PEM
         tsoil_PEM(:,l,:) = tsoil_ave(:,nsoilmx,:)
         watersoil_density_PEM_timeseries(:,l,:,:) = watersoil_density_timeseries(:,nsoilmx,:,:)
     enddo
-    watersoil_density_PEM_ave(:,:,:) = sum(watersoil_density_PEM_timeseries(:,:,:,:),4)/timelen
+    watersoil_density_PEM_ave = sum(watersoil_density_PEM_timeseries,4)/timelen
 endif !soil_pem
-deallocate(tsoil_ave,tsoil_GCM_timeseries)
+deallocate(tsoil_ave,tsoil_PCM_timeseries)
 
 !------------------------
@@ -553,14 +538,11 @@
 !    I_f Compute tendencies
 !------------------------
-allocate(tendencies_co2_ice(ngrid,nslope))
-allocate(tendencies_co2_ice_ini(ngrid,nslope))
-allocate(tendencies_h2o_ice(ngrid,nslope))
+allocate(tend_co2_ice(ngrid,nslope),tend_h2o_ice(ngrid,nslope))
+allocate(tend_co2_ice_ini(ngrid,nslope))
 
 ! Compute the tendencies of the evolution of ice over the years
-call compute_tendencies_slope(ngrid,nslope,min_co2_ice_1,min_co2_ice_2,tendencies_co2_ice)
-tendencies_co2_ice_ini(:,:) = tendencies_co2_ice(:,:)
-call compute_tendencies_slope(ngrid,nslope,min_h2o_ice_1,min_h2o_ice_2,tendencies_h2o_ice)
-
-deallocate(min_co2_ice_1,min_co2_ice_2,min_h2o_ice_1,min_h2o_ice_2)
+call compute_tend(ngrid,nslope,min_co2_ice,tend_co2_ice)
+call compute_tend(ngrid,nslope,min_h2o_ice,tend_h2o_ice)
+tend_co2_ice_ini = tend_co2_ice
 
 !------------------------
